import { EndpointGetFunction } from 'request-registry';
import { Observable } from 'rxjs';
declare type EndpointKeys<TEndpointGetFunction> = TEndpointGetFunction extends EndpointGetFunction<infer TKeys, any> ? TKeys : never;
declare type EndpointResult<TEndpointGetFunction> = TEndpointGetFunction extends EndpointGetFunction<any, infer TResult> ? TResult : never;
declare type EndpointState<TResult> = {
    busy: true;
    value: undefined;
    state: 'LOADING';
    hasData: false;
} | {
    busy: false;
    value: undefined;
    state: 'ERROR';
    hasData: false;
} | {
    busy: true;
    value: TResult;
    state: 'UPDATING';
    hasData: true;
} | {
    busy: false;
    value: TResult;
    state: 'DONE';
    hasData: true;
};
/**
 * Returns an Observable for the endpoint staten
 */
export declare const createObservableEndpoint: <TEndpoint extends EndpointGetFunction<any, any>>(endpoint: TEndpoint, keys: EndpointKeys<TEndpoint>) => Observable<EndpointState<EndpointResult<TEndpoint>>>;
/**
 * Returns an Observable for the endpoint result
 */
export declare function createObservableEndpointResponse<TEndpoint extends EndpointGetFunction<any, any>>(endpoint: TEndpoint, keys: EndpointKeys<TEndpoint>): Observable<EndpointResult<TEndpoint>>;
export {};
